function Q=basisTrans(q,r,dr,method,m)
% basisTrans Transform the bases for different kinds of sub-regions

Q=struct;
switch m
    case 'full'
        Q(1).value=q;
    case 'round'
        mask=logical(getRoundWindow(r));
        Q(1).value=zeros(size(q,1),size(q,2));
        Q(1).value(mask(:),:)=q(mask(:),:);
    case 'circle'
        nc=ceil(r/dr);
        mask=zeros(2*r+1,2*r+1);
        mask(r-dr+1:r+dr+1,r-dr+1:r+dr+1,1)=logical(getRoundWindow(dr));
        Q(1).value=zeros(size(q,1),size(q,2));
        Q(1).value(logical(mask(:)),:)=q(logical(mask(:)),:,1);
        for i=2:nc
            r1=(i-1)*dr;
            r2=min(i*dr,r);
            round=zeros(2*r2+1,2*r2+1);
            round(r2-r1+1:r2+r1+1,r2-r1+1:r2+r1+1)=getRoundWindow(r1);
            mask=zeros(2*r+1,2*r+1);
            mask(r-r2+1:r+r2+1,r-r2+1:r+r2+1)=logical(getRoundWindow(r2)-round);
            Q(i).value=zeros(size(q,1),size(q,2));
            Q(i).value(logical(mask(:)),:)=q(logical(mask(:)),:,1);
        end
    case '4*4'
        if(strcmp(method,'SURF'))
            L=2*r+1;
            w=zeros(L,L,16);
            for i=1:4
                for j=1:4
                    w((j-1)*r/2+1:j*r/2,(i-1)*r/2+1:i*r/2,(i-1)*4+j)=1;
                end
            end
%             L=2*r+2*4+1;
%             w=zeros(L,L,16);
%             for i=1:4
%                 for j=1:4
%                     w((j-1)*r/2+1:j*r/2+8,(i-1)*r/2+1:i*r/2+8,(i-1)*4+j)=1;
%                 end
%             end
        else
            y=[];
            x=[];
            for i=1:2*r+1
                x=[x;i*ones(2*r+1,1)];
                y=[y;[1:2*r+1]'];
            end
            sub_num=mod(ceil(y/(r/2)),5)+4*mod(ceil(x/(r/2))-1,5);
        end
        N=size(q,3);
        if(N>1)
            for i=1:16
%                 index=find(sub_num==i);
                index=w(:,:,i);
                qx=zeros(size(q,1),size(q,2));
                qx(:,logical(index(:)))=q(:,logical(index(:)),1);
                qy=zeros(size(q,1),size(q,2));
                qy(:,logical(index(:)))=q(:,logical(index(:)),2);
                Q(i).x=sparse(qx);
                Q(i).y=sparse(qy);
            end
        else
            for i=1:16
                index=find(sub_num==i);
                Q(i).value=zeros(size(q,1),size(q,2));
%                 [qq,rr]=qr(q(index,:),0);
%                 Q(i).value(index,:)=qq;
                Q(i).value(index,:)=q(index,:);
                Q(i).value=sparse(Q(i).value);
            end
        end
        case '2*2'
        if(strcmp(method,'SURF'))
            L=2*r+1;
            w=zeros(L,L,4);
            for i=1:2
                for j=1:2
                    w((j-1)*r+1:j*r,(i-1)*r+1:i*r/2,(i-1)*2+j)=1;
                end
            end
        else
            y=[];
            x=[];
            for i=1:2*r+1
                x=[x;i*ones(2*r+1,1)];
                y=[y;[1:2*r+1]'];
            end
            sub_num=mod(ceil(y/r),3)+2*mod(ceil(x/r)-1,3);
        end
        N=size(q,3);
        if(N>1)
            for i=1:4
%                 index=find(sub_num==i);
                index=w(:,:,i);
                qx=zeros(size(q,1),size(q,2));
                qx(:,logical(index(:)))=q(:,logical(index(:)),1);
                qy=zeros(size(q,1),size(q,2));
                qy(:,logical(index(:)))=q(:,logical(index(:)),2);
                Q(i).x=sparse(qx);
                Q(i).y=sparse(qy);
            end
        else
            for i=1:4
                index=find(sub_num==i);
                Q(i).value=zeros(size(q,1),size(q,2));
                [qq,rr]=qr(q(index,:),0);
                Q(i).value(index,:)=qq;
%                 Q(i).value(index,:)=q(index,:);
                Q(i).value=sparse(Q(i).value);
            end
        end
end