% This is demo code for the paper
% "A Feature Descriptor by Difference of Polynomials", B. Zheng, Y. Sun, J.
% Takamatsu and Ikeuchi, IPSJ transaction on CVA 2013.
% If you get any problem, please contact us by email
% zheng@cvl.iis.u-tokyo.ac.jp

img1=imread('data\google\koukyo0a.jpg');
img2=imread('data\google\koukyo4a.jpg');
% For saving time, we recommand the authors can resize image to be lower
% than 640*480
img1 = imresize(img1,0.2);
img2 = imresize(img2,0.2);

% transform to gray-scale image
img1=double(rgb2gray(img1))/255;
img2=double(rgb2gray(img2))/255;

% you can adjust the window size for improve accuracy 
[kp1]=myDetector(img1,0.02,3,10,0); % Feature detection with window size = 10
[kp2]=myDetector(img2,0.02,3,10,0); 

% Feature mathching with 1) Polynomial degree 0-4, 2) window size = 10, 
% 3) threshold dis(p1,p2)_1st/dis(p1,p2)_2nd <= 0.75
[matches,m,descriptor1,descriptor2]=Feature_matching(img1,img2,kp1,kp2,0,4,10,1,'EP','4*4',100,0.75,0,1);
