function [kp_out]=inportKP2(kp_in,Rmin)
%inportKP2 Transform the format of keypoints taken by other program (such
%as codes by K. Mikolajczyk) into which our program can deal with.
%[y,x,A,B,C] or [y,x,alpha,a,b], A, B, C are coefficients of ellipse and
%a,b are the two axises. 

N=kp_in(1);
n=kp_in(2);
kp_temp=zeros(n,5);
ind=logical(zeros(n,1));
ind(1)=1;
for i=1:n
    k=3+(i-1)*(N+5);
    p=kp_in(k:k+4);
    x=round(p(1));
    y=round(p(2));
    A=p(3);
    B=p(4);
    C=p(5);
    a=1/sqrt(A);
    b=1/sqrt(C);
    alpha=atan(2*B/(A-C))/2;
    kp_temp(i,:)=[y,x,A,B,C];
%     kp_temp(i,:)=[y,x,alpha,a,b];
end
for j=2:n
    if(kp_temp(j,:)~=kp_temp(j-1,:))
        ind(j)=1;
    end
end
kp_out=kp_temp(ind,:);
% kp_out=kp_out(kp_out(:,4)<=1/(Rmin^2)&kp_out(:,5)<=1/(Rmin^2),:);