function [kp_out]=orientation(img,kp,r,kk,th)
%orientation Assign the dominant orientation using the similar method as
%SIFT. 

[lines,columns]=size(img);
num_kp=size(kp,1);
kp_out=[];
for i=1:num_kp
    patch=img(kp(i,1)-r:kp(i,1)+r,kp(i,2)-r:kp(i,2)+r);
%     h=fspecial('gaussian',2*r+1,r/kk);
    h=fspecial('gaussian',2*r+1,r/4);
    h=h/max(max(h));
    patch=patch.*h;
    NBINS=36;
    dx_filter = [-0.5 0 0.5];
    dy_filter = dx_filter';
    gradient_x = imfilter(patch, dx_filter);
    gradient_y = imfilter(patch, dy_filter);
    magnitudes =sqrt( gradient_x.^2 + gradient_y.^2);
    angles = mod(atan(gradient_y ./ (eps + gradient_x))+0.5*(1-sign(gradient_x))*pi + 2*pi, 2*pi);
    angles(isnan(angles))=pi/2;
    sigmaw=r/4;
    histo = zeros(1, NBINS);
    x=r+1;
    y=r+1;
    xp=floor(x+0.5);
    yp=floor(y+0.5);
    iii=0;
    for xs = xp - max(r, xp-1): min((columns - 2), xp + r)
        for ys = yp - max(r, yp-1) : min((lines-2), yp + r)
            iii=iii+1;
            dx = (xs - x);
            dy = (ys - y);
            if dx^2 + dy^2 <= r^2 % the points are within the circle
                wincoef = exp(-(dx^2 + dy^2)/(2*sigmaw^2));
                bin = round( NBINS *  angles(ys, xs)/(2*pi) + 0.5);
                histo(bin) = histo(bin) + wincoef * magnitudes(ys, xs);
            end
        end
    end
    theta_max = max(histo);
%     theta_indx = find(histo==theta_max);      %Select only the largest orientation.
    theta_indx = find(histo> th * theta_max);   %Select several orientations.
    for j=1:size(theta_indx,2)
        kp_out=[kp_out;[kp(i,:),2*pi * theta_indx(j) / NBINS]];
    end
end
